//////////////////////////////////////////////////////////////////////////////////////////
////                                                                                  ////
////                                 Global Variables                                 ////
////                                                                                  ////
//////////////////////////////////////////////////////////////////////////////////////////
extern int MagicNumber=10001;
extern double baseLotSize=0.01;
extern int Step=10;
extern double TargetProfit;

int Slippage=3;
double MyPoint=Point;

///////////////////////////////////////////////////////////////////////////////////////////
////                                                                                   ////
////                                   Main Function                                   ////
////                                                                                   ////
///////////////////////////////////////////////////////////////////////////////////////////
int start()
{
  if(Digits==3 || Digits==5)
  MyPoint=Point*10;
  double accountBalance=AccountBalance();
  
  if(NormalizeDouble(accountBalance, 2) >= NormalizeDouble(TargetProfit, 2))
  {
    Comment("Profit Target Was Reached!\n", "TargetProfit Must only be Greater than Account Balance.");
  }
  
  if(
      (NormalizeDouble(accountBalance, 2) < NormalizeDouble(TargetProfit, 2))
      ||
      (
        (NormalizeDouble(accountBalance, 2) >= NormalizeDouble(TargetProfit, 2))&&
        (OrdersTotal()>0)
      )
    )
  {
    deleteAllPendingOrders();
    openActiveOrders();
    setStopLimit();
    openPendingOrders();
    
    /*if(OrdersTotal()==0)
    {
      if(MathRand()%2==0)
      openBuy();
      else
      openSell();
      
    }
    
    if(OrdersTotal()>0)
    {
      if(totalPendingOrders()>0 && totalActiveOrders()==0)
      {
        deleteAllPendingOrders();
      }
      if(totalActiveOrders()>0)
      {
        setStopLimit();
        openPendingOrders();
      }
    }*/
  }
  return true;
}

//////////////////////////////////////////////////////////////////////////////////////////
////                                                                                  ////
////                                 Custom Functions                                 ////
////                                                                                  ////
//////////////////////////////////////////////////////////////////////////////////////////
int openSell()
{
  if(OrderSend(Symbol(),OP_SELL,getLotSize(),Bid,Slippage,0,0,"ExtremeHedge",MagicNumber,0,Red))
  return true;
  return true;
}

//----------------------------------------------------------------------------------------------------------------------------------------
int openBuy()
{
  if(OrderSend(Symbol(),OP_BUY,getLotSize(),Ask,Slippage,0,0,"ExtremeHedge",MagicNumber,0,Blue))
  return true;
  return true;
}

//----------------------------------------------------------------------------------------------------------------------------------------
double getLotSize()
{
  //double lotSize = maxActiveOrderLotSize()+(baseLotSize*lotSizeMultiplier);
  //double lotSize = baseLotSize;
  
  int simpleLot=AccountBalance()/10000;
  double transactedLot=simpleLot;
  double lotSize = NormalizeDouble(transactedLot/100, 2);
  
  double min_lot = SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_MIN);
  double max_lot = SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_MAX);

  if(lotSize < min_lot)
  lotSize = min_lot;

  if(lotSize > max_lot)
  lotSize = max_lot;

  return (lotSize);
}

//----------------------------------------------------------------------------------------------------------------------------------------
int setStopLimit()
{
  for(int i=OrdersTotal()-1; i>=0; i--)
  { 
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
      int orderType=OrderType();
      int orderTicket=OrderTicket();
      double orderOpenPrice=OrderOpenPrice();
      double orderStopLoss=OrderStopLoss();
      double orderTakeProfit=OrderTakeProfit();
      
      if(orderType==OP_BUY)
      {
        if(orderOpenPrice==maxBuyOrder())
        {
          if(OrderModify(orderTicket, orderOpenPrice, orderStopLoss, buyStopLimitLevel(), 0, Red))
          continue;
        }
        if(orderOpenPrice!=maxBuyOrder())
        {
          if(OrderModify(orderTicket, orderOpenPrice, orderStopLoss, buyStopLimitLevel(), 0, Red))
          continue;
        }
      }
      if(orderType==OP_SELL)
      {
        if(orderOpenPrice==maxSellOrder())
        {
          if(OrderModify(orderTicket, orderOpenPrice, orderStopLoss, sellStopLimitLevel(), 0, Red))
          continue;
        }
        if(orderOpenPrice!=maxSellOrder())
        {
          if(OrderModify(orderTicket, orderOpenPrice, orderStopLoss, sellStopLimitLevel(), 0, Red))
          continue;
        }
      }
    }
  }
  return true;
}

//----------------------------------------------------------------------------------------------------------------------------------------
int openPendingOrders()
{
  /*if(OrderSelect(OrdersTotal()-1, SELECT_BY_POS, MODE_TRADES))
  {
    int orderType=OrderType();
    int orderTicket=OrderTicket();
    double orderOpenPrice=OrderOpenPrice();
    double orderStopLoss=OrderStopLoss();
    double orderTakeProfit=OrderTakeProfit();
    
    if(orderType==OP_BUY)
    {
      if(OrderSend(Symbol(), OP_BUYLIMIT, nextPendingBuyLotSize(), buyRecoveryLevel(),Slippage,0,0,"Grender",MagicNumber,0,Blue))
      return true;
    }
    if(orderType==OP_SELL)
    {
      if(OrderSend(Symbol(), OP_SELLLIMIT, nextPendingSellLotSize(), sellRecoveryLevel(),Slippage,0,0,"Grender",MagicNumber,0,Red))
      return true;
    }
  }*/
  if(activeBuyOrders()>0 && pendingBuyOrders()==0)
  {
    if(OrderSend(Symbol(), OP_BUYLIMIT, nextPendingBuyLotSize(), buyRecoveryLevel(),Slippage,0,0,"Grender",MagicNumber,0,Blue))
    return true;
  }
  if(activeSellOrders()>0 && pendingSellOrders()==0)
  {
    if(OrderSend(Symbol(), OP_SELLLIMIT, nextPendingSellLotSize(), sellRecoveryLevel(),Slippage,0,0,"Grender",MagicNumber,0,Red))
    return true;
  }
  return true;
}

//----------------------------------------------------------------------------------------------------------------------------------------
double buyRecoveryLevel()
{
  double buyRecoveryLevel=0;
  
  for(int i=OrdersTotal()-1; i>=0; i--)
  {
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
      double orderOpenPrice=OrderOpenPrice();
      
      if(orderOpenPrice==maxBuyOrder())
      {
        buyRecoveryLevel=orderOpenPrice-(Step*MyPoint);
        continue;
      }
    }
  }
  return buyRecoveryLevel;
}

//----------------------------------------------------------------------------------------------------------------------------------------
double sellRecoveryLevel()
{
  double sellRecoveryLevel=0;
  
  for(int i=OrdersTotal()-1; i>=0; i--)
  {
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
      double orderOpenPrice=OrderOpenPrice();
      
      if(orderOpenPrice==maxSellOrder())
      {
        sellRecoveryLevel=orderOpenPrice+(Step*MyPoint);
        continue;
      }
    }
  }
  return sellRecoveryLevel;
}

//----------------------------------------------------------------------------------------------------------------------------------------
double buyStopLimitLevel()
{
  return maxBuyOrder()+(Step*MyPoint);
}

//----------------------------------------------------------------------------------------------------------------------------------------
double sellStopLimitLevel()
{
  return maxSellOrder()-(Step*MyPoint);
}

//----------------------------------------------------------------------------------------------------------------------------------------
double maxBuyOrder()
{
  double maxOrderOpenPrice=0;
  double orderOpenPrice;
  double orderType;
      
  for(int j=OrdersTotal()-1; j>=0; j--)
  {
    if(OrderSelect(j, SELECT_BY_POS, MODE_TRADES))
    {
      orderOpenPrice=OrderOpenPrice();
      orderType=OrderType();
      
      if(orderType==OP_BUY)
      maxOrderOpenPrice=orderOpenPrice;
    }
  }
  
  for(int i=OrdersTotal()-1; i>=0; i--)
  {
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
      orderOpenPrice=OrderOpenPrice();
      orderType=OrderType();
      
      if(orderType==OP_BUY)
      {
        maxOrderOpenPrice=MathMin(maxOrderOpenPrice, orderOpenPrice);
        continue;
      }
    }
  }
  return maxOrderOpenPrice;
}

//----------------------------------------------------------------------------------------------------------------------------------------
double maxSellOrder()
{
  double maxOrderOpenPrice=0;
  
  for(int i=OrdersTotal()-1; i>=0; i--)
  {
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
      double orderOpenPrice=OrderOpenPrice();
      double orderType=OrderType();
      
      if(orderType==OP_SELL)
      {
        maxOrderOpenPrice=MathMax(maxOrderOpenPrice, orderOpenPrice);
        continue;
      }
    }
  }
  return maxOrderOpenPrice;
}

//----------------------------------------------------------------------------------------------------------------------------------------
int deleteAllPendingOrders()
{
  if(activeBuyOrders()==0 && pendingBuyOrders()!=0)
  {
    for(int i=OrdersTotal()-1; i>=0; i--)
    {
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      {
        int orderType=OrderType();
        int orderTicket=OrderTicket();
        
        if(orderType==OP_BUYLIMIT)
        {
          if(OrderDelete(orderTicket, Red))
          continue;
        }
      }
    }
  }
  if(activeSellOrders()==0 && pendingSellOrders()!=0)
  {
    for(int j=OrdersTotal()-1; j>=0; j--)
    {
      if(OrderSelect(j, SELECT_BY_POS, MODE_TRADES))
      {
        orderType=OrderType();
        orderTicket=OrderTicket();
        
        if(orderType==OP_SELLLIMIT)
        {
          if(OrderDelete(orderTicket, Red))
          continue;
        }
      }
    }
  }
  return true;
}

//----------------------------------------------------------------------------------------------------------------------------------------
int totalActiveOrders()
{
  int totalActiveOrders=0;
  
  for(int i=OrdersTotal()-1; i>=0; i--)
  {
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
      int orderType=OrderType();
      
      if(orderType==OP_BUY || orderType==OP_SELL)
      {
        totalActiveOrders++;
        continue;
      }
    }
  }
  return totalActiveOrders;
}

//----------------------------------------------------------------------------------------------------------------------------------------
int totalPendingOrders()
{
  int totalPendingOrders=0;
  
  for(int i=OrdersTotal()-1; i>=0; i--)
  {
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
      int orderType=OrderType();
      
      if(orderType==OP_BUYLIMIT || orderType==OP_SELLLIMIT)
      {
        totalPendingOrders++;
        continue;
      }
    }
  }
  return totalPendingOrders;
}

//----------------------------------------------------------------------------------------------------------------------------------------
double nextPendingBuyLotSize()
{
  double totalBuyLots=0;
  
  for(int i=OrdersTotal()-1; i>=0; i--)
  {
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
      int orderType=OrderType();
      double orderLots=OrderLots();
      
      if(orderType==OP_BUY)
      {
        totalBuyLots=totalBuyLots+orderLots;
        continue;
      }
    }
  }
  if(totalBuyLots==0)
  return getLotSize();
  else
  return totalBuyLots;
}

//----------------------------------------------------------------------------------------------------------------------------------------
double nextPendingSellLotSize()
{
  double totalSellLots=0;
  
  for(int i=OrdersTotal()-1; i>=0; i--)
  {
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
      int orderType=OrderType();
      double orderLots=OrderLots();
      
      if(orderType==OP_SELL)
      {
        totalSellLots=totalSellLots+orderLots;
        continue;
      }
    }
  }
  if(totalSellLots==0)
  return getLotSize();
  else
  return totalSellLots;
}

//----------------------------------------------------------------------------------------------------------------------------------------
int openActiveOrders()
{
  if(activeBuyOrders()==0 && activeSellOrders()==0)
  {
    if(OrderSend(Symbol(),OP_SELL,getLotSize(),Bid,Slippage,0,0,"ExtremeHedge",MagicNumber,0,Red))
    {
      if(OrderSend(Symbol(),OP_BUY,getLotSize(),Ask,Slippage,0,0,"ExtremeHedge",MagicNumber,0,Blue))
      return true;
    }
  }
  
  if(activeBuyOrders()==0 && activeSellOrders()!=0)
  {
    if(OrderSend(Symbol(),OP_BUY,getLotSize(),Ask,Slippage,0,0,"ExtremeHedge",MagicNumber,0,Blue))
    return true;
  }
  
  if(activeSellOrders()==0 && activeBuyOrders()!=0)
  {
    if(OrderSend(Symbol(),OP_SELL,getLotSize(),Bid,Slippage,0,0,"ExtremeHedge",MagicNumber,0,Red))
    return true;
  }
  return true;
}

//----------------------------------------------------------------------------------------------------------------------------------------
int activeBuyOrders()
{
  int totalActiveBuyOrders=0;
  
  for(int i=OrdersTotal()-1; i>=0; i--)
  {
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
      int orderType=OrderType();
      
      if(orderType==OP_BUY)
      {
        totalActiveBuyOrders++;
        continue;
      }
    }
  }
  return totalActiveBuyOrders;
}

//----------------------------------------------------------------------------------------------------------------------------------------
int activeSellOrders()
{
  int totalActiveSellOrders=0;

  for(int i=OrdersTotal()-1; i>=0; i--)
  {
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
      int orderType=OrderType();
      
      if(orderType==OP_SELL)
      {
        totalActiveSellOrders++;
        continue;
      }
    }
  }
  return totalActiveSellOrders;
}

//----------------------------------------------------------------------------------------------------------------------------------------
int pendingBuyOrders()
{
  int totalPendingBuyOrders;
  
  for(int i=OrdersTotal()-1; i>=0; i--)
  {
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
      int orderType=OrderType();
      
      if(orderType==OP_BUYLIMIT)
      {
        totalPendingBuyOrders++;
        continue;
      }
    }
  }
  return totalPendingBuyOrders;
}

//----------------------------------------------------------------------------------------------------------------------------------------
int pendingSellOrders()
{
  int totalPendingSellOrders=0;
  
  for(int i=OrdersTotal()-1; i>=0; i--)
  {
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
      int orderType=OrderType();
      
      if(orderType==OP_SELLLIMIT)
      {
        totalPendingSellOrders++;
        continue;
      }
    }
  }
  return totalPendingSellOrders;
}

//----------------------------------------------------------------------------------------------------------------------------------------